/* c_option.cc
 *$Header: /al/acs/src/RCS/c_option.cc,v 7.98 95/04/19 01:04:48 al Exp $
 * set and view options and user controllable variables
 */
#include "ecah.h"
#include "ap.h"
#include "error.h"
#include "io.h"
#include "u_option.h"
#include "c_comand.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
//	void	CMD::options(CS&);
/*--------------------------------------------------------------------------*/
void CMD::options(CS& cmd)
{
  int dummy;
  int ii;
  double arg1, arg2;
  int changed = NO;
  
  while (cmd.more()){
 			/* didsomething avoids heap space problem in MSC */
    int didsomething = cmd.argparse(REPEAT,
    	"ACCT",		aENUM,		&OPT::acct,	YES,
    	"NOACCT",	aENUM,		&OPT::acct,	NO,
	"LIST",		aENUM,		&OPT::list,	YES,
	"NOLIST",	aENUM,		&OPT::list,	NO,
	"MOD",		aENUM,		&OPT::nomod,	NO,
	"NOMOD",	aENUM,		&OPT::nomod,	YES,
	"PAGE",		aENUM,		&OPT::page,	YES,
	"NOPAGE",	aENUM,		&OPT::page,	NO,
	"NODE",		aENUM,		&OPT::node,	YES,
	"NONODE",	aENUM,		&OPT::node,	NO,
	"OPTS",		aENUM,		&OPT::opts,	YES,
	"NOOPTS",	aENUM,		&OPT::opts,	NO,
	"GMIN",		aUDOUBLE,	&OPT::gmin,
	"RELTOL",	aUDOUBLE,	&OPT::reltol,
	"ABSTOL",	aUDOUBLE,	&OPT::abstol,
	"VNTOL",	aUDOUBLE,	&OPT::vntol,
	"TRTOL",	aUDOUBLE,	&OPT::trtol,
	"CHGTOL",	aUDOUBLE,	&OPT::chgtol,
	"PIVTOL",	aUDOUBLE,	&OPT::pivtol,
	"PIVREL",	aUDOUBLE,	&OPT::pivrel,
	"NUMDGT",	aFINT,		&OPT::numdgt,
	"TNOM",		aODOUBLE,	&OPT::tnom,	-ABS_ZERO,
	"CPTIME",	aFINT,		&OPT::cptime,
	"LIMTIM",	aFINT,		&OPT::limtim,
	"LIMPTS",	aFINT,		&OPT::limpts,
	"LVLCOD",	aFINT,		&OPT::lvlcod,
	"LVLTIM",	aFINT,		&OPT::lvltim,
	"METHOD",	aENUM,		&dummy,		YES,
	"GEAR",		aENUM,		&OPT::method,	mGEAR,
	"TRAPezoidal",	aENUM,		&OPT::method,	mTRAPEZOID,
	"MAXORD",	aFINT,		&OPT::maxord,
	"DEFL", 	aUDOUBLE,	&OPT::defl,
	"DEFW", 	aUDOUBLE,	&OPT::defw,
	"DEFAD",	aUDOUBLE,	&OPT::defad,
	"DEFAS",	aUDOUBLE,	&OPT::defas,
 	"");
    if (didsomething)
      changed = YES;
    else if (cmd.argparse(REPEAT,
	"Seed",		aFINT,		&OPT::seed,
	"WCZero",	aUDOUBLE,	&OPT::wczero,
	"Damp",		aUDOUBLE,	&OPT::damp,
	"Floor",	aUDOUBLE,	&OPT::floor,
	"Tempamb",	aODOUBLE,	&OPT::tempamb,	-ABS_ZERO,
	"Short",	aUDOUBLE,	&OPT::shortckt,
	"TRansits",	aFINT,		&OPT::transits,
	"INwidth",	aFINT,		&OPT::inwidth,
	"OUTwidth",	aFINT,		&OPT::outwidth,
	"XDivisions",	aUDOUBLE,	&OPT::xdivisions,
	"YDivisions",	aUDOUBLE,	&OPT::ydivisions,
 	""))
      changed = YES;
    else if (cmd.argparse(REPEAT,
	"NAG",		aENUM,		&OPT::picky,	bNOERROR,
	"NONAG",	aENUM,		&OPT::picky,	bTRACE,
	"TRACE",	aENUM,		&OPT::picky,	bTRACE,
	"NOTRACE",	aENUM,		&OPT::picky,	bLOG,
	"LOG",		aENUM,		&OPT::picky,	bLOG,
	"NOLOG",	aENUM,		&OPT::picky,	bDEBUG,
	"DEBUG",	aENUM,		&OPT::picky,	bDEBUG,
	"NODEBUG",	aENUM,		&OPT::picky,	bPICKY,
	"PICKY",	aENUM,		&OPT::picky,	bPICKY,
	"NOPICKY",	aENUM,		&OPT::picky,	bWARNING,
	"WARNing",	aENUM,		&OPT::picky,	bWARNING,
	"NOWARN",	aENUM,		&OPT::picky,	bDANGER,
	"ERRor",	aENUM,		&OPT::picky,	bERROR,
	"NOERRor",	aENUM,		&OPT::picky,	bDISASTER,
	"DISASTER",	aENUM,		&OPT::picky,	bDISASTER,
	""))
      changed = YES;
    else if (cmd.argparse(REPEAT,
	"ORder",	aENUM,		&dummy,		YES,
	"REVerse",	aENUM,		&OPT::order,	oREVERSE,
	"FORward",	aENUM,		&OPT::order,	oFORWARD,
	"AUTo",		aENUM,		&OPT::order,	oAUTO,
	"MODe",		aENUM,		&dummy,		YES,
	"ANAlog",	aENUM,		&OPT::mode,	mANALOG,
	"DIGital",	aENUM,		&OPT::mode,	mDIGITAL,
	"MIXed",	aENUM,		&OPT::mode,	mMIXED,
	"DUPcheck",	aENUM,		&OPT::dupcheck,	YES,
	"NODUPcheck",	aENUM,		&OPT::dupcheck,	NO,
	"BYPass",	aENUM,		&OPT::bypass,	YES,
	"NOBYPass",	aENUM,		&OPT::bypass,	NO,
	"VBYPass",	aENUM,		&OPT::bypass,	bVOLT,
	"INCmode",	aENUM,		&OPT::incmode,	YES,
	"NOIncmode",	aENUM,		&OPT::incmode,	NO,
	"LUBypasss",	aENUM,		&OPT::lubypass,	YES,
	"NOLUbypass",	aENUM,		&OPT::lubypass,	NO,
	"LIMIT",	aUDOUBLE,	&OPT::limit,
	"VMAX",		aDOUBLE,	&OPT::vmax,
	"VMIN",		aDOUBLE,	&OPT::vmin,
	"MRT",		aUDOUBLE,	&OPT::dtmin,
	"DTMIn",	aUDOUBLE,	&OPT::dtmin,
	"DTRatio",	aUDOUBLE,	&OPT::dtratio,
	"RSTray",	aENUM,		&OPT::rstray,	YES,
	"NORSTray",	aENUM,		&OPT::rstray,	NO,
	"CSTray",	aENUM,		&OPT::cstray,	YES,
	"NOCSTray",	aENUM,		&OPT::cstray,	NO,
	"Harmonics",	aFINT,		&OPT::harmonics,
	"TRSTEPGrow",	aUDOUBLE,	&OPT::trstepgrow,
	"TRSTEPShrink",	aUDOUBLE,	&OPT::trstepshrink,
	"TRReject",	aUDOUBLE,	&OPT::trreject,
	"SHOWALL",	aENUM,		&OPT::showall,	YES,
	"NOSHOWALL",	aENUM,		&OPT::showall,	NO,
	"FOOOO",	aFINT,		&OPT::foooo,
	"DIODEflags",	aOCTAL,		&OPT::diodeflags,
	"MOSflags",	aOCTAL,		&OPT::mosflags,
 	""))
      changed = YES;
    else if (ii = cmd.index(), cmd.argparse(ONEPASS,
        "ITL",		a2DOUBLE,	&arg1,		&arg2,
	"")){
      if ((int)arg1 >= 1  &&  (int)arg1 < ITL_COUNT){
	OPT::itl[(int)arg1] = (int)arg2;
      }else{
	cmd.reset(ii);
	cmd.check(bWARNING);
	cmd.skiparg();
      }
      changed = YES;
    }else{
      cmd.check(bWARNING);
      cmd.skiparg();
    }
  }
  
  if (changed){
    dealloc(YES);
    OPT::lowlim = 1 - OPT::reltol;
    OPT::uplim  = 1 + OPT::reltol;
    OPT::outwidth = abs(OPT::outwidth);
    if (OPT::outwidth > MAXWIDTH)
      OPT::outwidth = MAXWIDTH;
  }
  
  if (!changed || OPT::opts){
    int where = IO::mstdout;
    mprintf(where, ".options ");
    if (OPT::acct)   mprintf(where," acct ");
    if (OPT::list)   mprintf(where," list ");
    if (OPT::nomod)  mprintf(where," nomod ");
    if (OPT::page)   mprintf(where," page ");
    if (OPT::node)   mprintf(where," node ");
    if (OPT::opts)   mprintf(where," opts ");
    mprintf(where, " gmin=%s ",   ftos(OPT::gmin,   "", 7, 0));
    mprintf(where, " reltol=%s ", ftos(OPT::reltol, "", 7, 0));
    mprintf(where, " abstol=%s ", ftos(OPT::abstol, "", 7, 0));
    mprintf(where, " vntol=%s ",  ftos(OPT::vntol,  "", 7, 0));
    mprintf(where, " trtol=%s ",  ftos(OPT::trtol,  "", 7, 0));
    mprintf(where, " chgtol=%s ", ftos(OPT::chgtol, "", 7, 0));
    mprintf(where, " pivtol=%s ", ftos(OPT::pivtol, "", 7, 0));
    mprintf(where, " pivrel=%s ", ftos(OPT::pivrel, "", 7, 0));
    mprintf(where, " numdgt=%d ", OPT::numdgt);
    mprintf(where, " tnom=%s ",   ftos(OPT::tnom+ABS_ZERO,   "", 7, 0));
    mprintf(where, " cptime=%d ", OPT::cptime);
    mprintf(where, " limtim=%d ", OPT::limtim);
    mprintf(where, " limpts=%d ", OPT::limpts);
    mprintf(where, " lvlcod=%d ", OPT::lvlcod);
    mprintf(where, " lvltim=%d ", OPT::lvltim);
    if (OPT::method == mTRAPEZOID) mprintf(where, " method=trapezoid ");
    else if (OPT::method == mGEAR) mprintf(where, " method=gear ");
    mprintf(where, " maxord=%d ", OPT::maxord);
    for (ii=1;  ii<ITL_COUNT;  ii++)
      mprintf(where, " itl%d=%d ", ii, OPT::itl[ii]);
    mprintf(where, " defl=%s ", ftos(OPT::defl, "", 7, 0));
    mprintf(where, " defw=%s ", ftos(OPT::defw, "", 7, 0));
    mprintf(where, " defad=%s ", ftos(OPT::defad, "", 7, 0));
    mprintf(where, " defas=%s ", ftos(OPT::defas, "", 7, 0));
    mprintf(where, " seed=%d ",   OPT::seed);
    mprintf(where, " wczero=%s ", ftos(OPT::wczero,  "", 7, 0));
    mprintf(where, " damp=%s ",   ftos(OPT::damp,    "", 7, 0));
    mprintf(where, " floor=%s ",  ftos(OPT::floor,   "", 7, 0));
    mprintf(where, " tempamb=%s ",ftos(OPT::tempamb+ABS_ZERO, "", 7, 0));
    mprintf(where, " short=%s ",  ftos(OPT::shortckt,"", 7, 0));
    mprintf(where, " in=%d ",     OPT::inwidth);
    mprintf(where, " out=%d ",    OPT::outwidth);
    mprintf(where, " xdivisions=%s ",  ftos(OPT::xdivisions,   "", 7, 0));
    mprintf(where, " ydivisions=%s ",  ftos(OPT::ydivisions,   "", 7, 0));
    if (OPT::order == oREVERSE) mprintf(where, " order=reverse ");
    else if (OPT::order == oFORWARD) mprintf(where, " order=forward ");
    else if (OPT::order == oAUTO) mprintf(where, " order=auto ");
    if (OPT::mode == mANALOG) mprintf(where, " mode=analog ");
    else if (OPT::mode == mDIGITAL) mprintf(where, " mode=digital ");
    else if (OPT::mode == mMIXED) mprintf(where, " mode=mixed ");
    mprintf(where, " transits=%d ",OPT::transits);
    mprintf(where," %sdupcheck ", ((OPT::dupcheck)?"":"no"));  
    if (OPT::bypass == NO) mprintf(where, " nobypass ");
    else if (OPT::bypass == YES) mprintf(where, " bypass ");
    else if (OPT::bypass == bVOLT) mprintf(where, " vbypass ");
    mprintf(where," %sincmode ", ((OPT::incmode)?"":"no"));    
    mprintf(where," %slubypass ", ((OPT::lubypass)?"":"no"));    
    mprintf(where, " limit=%s ",  ftos(OPT::limit,"", 7, 0));
    mprintf(where, " vmax=%s ",  ftos(OPT::vmax,"", 7, 0));
    mprintf(where, " vmin=%s ",  ftos(OPT::vmin,"", 7, 0));
    mprintf(where, " dtmin=%s ",  ftos(OPT::dtmin,"", 7, 0));
    mprintf(where, " dtratio=%s ",  ftos(OPT::dtratio,"", 7, 0));
    mprintf(where," %srstray ", ((OPT::rstray)?"":"no"));    
    mprintf(where," %scstray ", ((OPT::cstray)?"":"no"));    
    mprintf(where, " harmonics=%d ", OPT::harmonics);
    mprintf(where, " trstepgrow=%s ",  ftos(OPT::trstepgrow,"", 7, 0));
    mprintf(where, " trstepshrink=%s ",  ftos(OPT::trstepshrink,"", 7, 0));
    mprintf(where, " trreject=%s ",  ftos(OPT::trreject,"", 7, 0));
    mprintf(where," %sshowall ", ((OPT::showall)?"":"no"));    
    if (OPT::showall){
      mprintf(where, " foooo=%d ", OPT::foooo);
      mprintf(where, " diodeflags=%o ", OPT::diodeflags);
      mprintf(where, " mosflags=%o ", OPT::mosflags);
    }
    mputc('\n',where);
  }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
