/* md_unix.h
 $Header: /al/acs/src/RCS/md_unix.h,v 7.100 95/04/22 21:57:20 al Exp $
 * Special stuff for all unix systems
 */
/* constants related to memory size, word size, etc */
#define SEGSIZ		9000000
#define	BUFLEN		256
#define BIGBUFLEN	2048
#define MAXWIDTH	512
#define PROBECOUNT	500
#define MAXEVENTCOUNT	2000
#define MAXFAULTS	100
#define SAVEITERATIONS	2
#define SAVEBACKTIME	4
#define DCNEST		4
#define RECURSE		8
#define LABELEN		8
#define MAXHANDLE	((int)((CHAR_BIT*sizeof(int))-1))

/* file names, etc. */
#define BEGINDIR	""
#define DIRSEP		"/"
#define	ENDDIR		"/"
#define PATHSEP		':'
#define SYSTEMSTARTFILE	"acs.rc"
#define SYSTEMSTARTPATH	getenv("PATH")
#define USERSTARTFILE	".acsrc"
#define	USERSTARTPATH	getenv("HOME")
#define EDITFILE   	"/tmp/EXXXXXX"
#define STEPFILE   	"/tmp/SXXXXXX"
#define PLOTFILE    	"acs.plot"
#define HELPFILE    	"acs.hlp"
#define HELPPATH	getenv("PATH")

/* standard collection of includes */
#include <assert.h>
#include <ctype.h>
#include <errno.h>
#include <limits.h>
#include <math.h>
#include <memory.h>
#include <setjmp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <complex.h>

/* non-standard collection of includes */
#if defined(NEXT)
#   include <libc.h>
#   include <unistd.h>
#else		/* assume for anything else */
#   include <unistd.h>
#   include <values.h>
#   include <sys/file.h>
#   include <sys/time.h>
#   include <sys/resource.h>
#endif

/* stuff not preperly defined in the supplied header files. */
#if defined(NEXT)
   extern "C" char *getcwd(char *,size_t);
#elif defined(OSF)
   extern "C" char *mktemp(char*);
#elif defined(SUN_CC)
   extern "C" int  getrusage(int,struct rusage*);
   extern "C" char *mktemp(char*);
   #define SIGNALARGS int,...
   inline void free(void* x){free((char*)x);}
   inline void* realloc(void* x, size_t n){return realloc((char*)x, n);}
#elif defined(SUN_GCC)
   extern "C" int  getrusage(int,struct rusage*);
   extern "C" char *mktemp(char*);
#endif

#ifndef SIGNALARGS
#define SIGNALARGS ...
#endif
